<script setup lang="ts">
import { ref, nextTick } from 'vue'
import { useUserStore } from '@/stores/user'

const userStore = useUserStore()
const image = ref([])
const imagePreview = ref(
  userStore.editedUser?.id && userStore.editedUser?.id >= 0
    ? `src/image/user/user${userStore.editedUser?.id}.png`
    : 'src/image/logo/action/Unknow.png'
)

async function selectImage(e: Event) {
  const input = e.target as HTMLInputElement
  const file = (input.files && input.files[0]) || null

  if (!file) return

  const readData = (f: any) => {
    const reader = new FileReader()
    return new Promise((resolve) => {
      reader.onloadend = () => {
        resolve(reader.result)
      }
      reader.readAsDataURL(f)
    })
  }
  const data = await readData(file)
  imagePreview.value = data as string
}

function clearImagePreview() {
  imagePreview.value = 'src/image/logo/action/Unknow.png'
}

async function saveImage() {
  if (!image.value || !image.value.length) return

  const imageName =
    userStore.editedUser?.id && userStore.editedUser?.id >= 0
      ? `user(${userStore.editedUser.id}).png`
      : `user(${userStore.users.length + 1}).png`

  const imagePath = `../image/user/${imageName}`

  // Convert base64 image to a Blob
  const base64Data = imagePreview.value.split(',')[1]

  const blob = await fetch(`data:image/png;base64,${base64Data}`).then((res) => res.blob())

  // Save the Blob to a file
  const a = document.createElement('a')
  document.body.appendChild(a)
  a.style.display = 'none'
  const url = window.URL.createObjectURL(blob)
  a.href = url
  a.download = imageName
  a.click()
  window.URL.revokeObjectURL(url)
}
</script>

<template>
  <v-card height="40vh" width="40vh">
    <v-card-text>
      <div class="d-flex align-center justify-center">
        <v-img
          :src="image ? imagePreview : 'src/image/logo/action/Unknow.png'"
          lazy-src="src/image/logo/action/Loading-1263.gif"
          height="20vh"
          width="20vh"
        ></v-img>
      </div>

      <v-file-input
        v-model="image"
        accept="image/png, image/jpeg, image/bmp"
        placeholder="Pick an image"
        prepend-icon="mdi-camera"
        @change="selectImage"
        @clear="clearImagePreview"
        label="Image"
      ></v-file-input>

      <v-btn @click="saveImage">Save Image</v-btn>
    </v-card-text>
  </v-card>
</template>
